#!/usr/bin/perl

use Net::WMI;
use Net::WMI::Connection;
use strict;


if($#ARGV != 0){
    print "Usage: test1.pl <vm name>\n";
    exit 1;
}
my $vm_name = $ARGV[0];

my $cim = Net::WMI::Connection->new( hostname => "192.168.1.9",
				     namespace => 'root\\cimv2',
				     user => 'Administrator',
				     pass => 'CSLpass1');

my $msvm = Net::WMI::Connection->new( hostname => "192.168.1.9",
				     namespace => 'root\\virtualization',
				     user => 'Administrator',
				     pass => 'CSLpass1');


my $host_name;
my $vm_uuid;
my $vm_ref;
my $found_vm = 0;
my $obj_ref;

my $enum = $cim->ExecQuery("select * from Win32_ComputerSystem");
$enum->Reset();
while(my $obj = $enum->Next()){
	my $val = $obj->{obj}->_GetProperty('Name');
	$host_name = $val->_GetSV($obj->{obj}->_GetPropertyType('Name'));
	print "Name: $host_name\n";
}

print "Searching VM name: $vm_name\n";
$enum = $msvm->ExecQuery("select * from Msvm_ComputerSystem where Name != '".$host_name."'");
$enum->Reset();
while(my $obj = $enum->Next()){
	my $val = $obj->{obj}->_GetProperty('Name');
	$vm_uuid = $val->_GetSV($obj->{obj}->_GetPropertyType('Name'));
	$val = $obj->{obj}->_GetProperty('ElementName');
	my $vmname = $val->_GetSV($obj->{obj}->_GetPropertyType('ElementName'));
	$vm_ref = $obj->{obj}->__PATH;
	print "VMName: $vmname\n";
	if($vmname eq $vm_name){		
		$found_vm = 1;
		last;
	}
}

if($found_vm == 1){
	print "Found, ref: $vm_ref\n";
}


$enum = $msvm->ExecQuery("select * from Msvm_VirtualSystemManagementService");
$enum->Reset();
while(my $obj = $enum->Next()){
	$obj_ref = $obj->{obj}->__PATH;
	print "OBJ REF: $obj_ref\n";
}


my $obj = $msvm->GetObject("Msvm_VirtualSystemManagementService");

my ($in, $out) = $obj->GetMethod("DestroyVirtualSystem");
my $inst = $in->SpawnInstance();
$inst->Put("ComputerSystem", $vm_ref);
$msvm->ExecMethod("\\\\HYPERV\\root\\virtualization:Msvm_VirtualSystemManagementService.CreationClassName=\"Msvm_VirtualSystemManagementService\",Name=\"vmms\",SystemCreationClassName=\"Msvm_ComputerSystem\",SystemName=\"HYPERV\"","DestroyVirtualSystem",$inst->{obj});


