#!/usr/bin/perl

use Net::WMI;
use Net::WMI::Connection;


if($#ARGV != 3){
    print "Usage: test1.pl <host> <user> <pass> <dir name>\n";
    print "# ./test.pl 192.168.1.1 Administrator CoolPass \"C:\\\\\\\\test_dir_tmp\"\n";
    exit 1;
}
my $host = $ARGV[0];
my $user = $ARGV[1];
my $pass = $ARGV[2];
my $dir = $ARGV[3];

my $con = Net::WMI::Connection->new( hostname => $host,
				    namespace => 'root\\cimv2', 
				    user => $user, 
				    pass => $pass);

my $obj = $con->GetObject("Win32_Process");
my ($in, $out) = $obj->GetMethod("Create");
my $inst = $in->SpawnInstance();
$inst->Put("CommandLine","cmd.exe /C mkdir $dir");
$con->ExecMethod("Win32_Process","Create",$inst->{obj});

print "Now, create/remove/rename file(s) in this dir, or ctrl-c to stop monitoring\n";

$enum = $con->ExecNotificationQuery("SELECT * FROM __InstanceOperationEvent WITHIN 1 WHERE Targetinstance ISA 'CIM_DirectoryContainsFile' and TargetInstance.GroupComponent= 'Win32_Directory.Name=\"$dir\"'");
while(1){
    $obj = $enum->Next();
    $cn = $obj->{obj}->_GetClassName();
    print "$cn\n";
}
